                     
var socket;
var text;

var musketSound;
var canonFireSound;
var explosionSound;
var dieSound;
var swordSound;

//var nameArray = ['Jonas','Erik','Svein','Lasse','Per','Emil','Markus','Jalle','Hasse','Geir','Ludvig','Albin','Mustafa','Oliver','Oscar','Simon','Viktor','Gustav','Elias'];

var selectionSoldierImage = new Image();
selectionSoldierImage.onload = function() {
};
selectionSoldierImage.src = 'Images/playerSelectionSoldier.png';
var selectionHorseImage = new Image();
selectionHorseImage.onload = function() {
};
selectionHorseImage.src = 'Images/playerSelectionHorse.png';
var selectionCanonImage = new Image();
selectionCanonImage.onload = function() {
};
selectionCanonImage.src = 'Images/playerSelectionCanon.png';

$(document).ready(function(){
	var iOS = ( navigator.userAgent.match(/(iPad|iPhone|iPod)/i) ? true : false );
	if(iOS){
		//setupSoundiOS();
	}
	else{
		//setupSound();
	}
	setUpActionEvents();
    
    connectToLocalServer();


	$(window).resize(function() {
	    resizeBackgroundFlag();
	});


	addBinding('verifyAcc', function(data){
		console.log('verify');
		if(data.canConnect){
			if(data.hasUsername){
				socket.emit('client', '');
			}
			else{
				socket.emit('client', prompt('Nickname:'));
			}
		}
		else{
			showTryAgain();
		}
	});

	addBinding('resync', function(data){
		console.log('resync' + data);
		drawBackgroundFlag(data.team);
		setup(data);
		console.log('resync done');
	})

	addBinding('setup', function(data){
		//console.log(data);
		drawBackgroundFlag(data.team);
		setup(data);
		if($(window).width() < 400){
			alert('If possible, use landscape mode.');
		}
	});

	addBinding('characterSelection', function(data){
		//setup(data);
		console.log('Character selection baby');
		drawBackgroundFlag(data.team);
  		showCharacterSelection(data);
	});


	addBinding('killPlayer', function(){
		//console.log('killed!');
		horseIsActive = false;
		//dieSound.play();
	});
});

function setupSoundiOS(){
	console.log('setup sound iOS');
	musketSound = new Audio("Sound/musket.m4a");
	canonFireSound = new Audio("Sound/canon_fire.m4a");
	explosionSound = new Audio("Sound/explosion.m4a");
	dieSound = new Audio("Sound/die.m4a");
	swordSound = new Audio("Sound/sword.m4a");
}

function setupSound(){
	console.log('setup sound');
	musketSound = new Audio("Sound/musket.ogg");
	canonFireSound = new Audio("Sound/canon_fire.ogg");
	explosionSound = new Audio("Sound/explosion.ogg");
	dieSound = new Audio("Sound/die.ogg");
	swordSound = new Audio("Sound/sword.ogg");
}

function showTryAgain(){
	$("#backgroundDiv").fadeIn(500, function() { $(this).css("display", "block"); });
}

function resizeBackgroundFlag(){
	//alert('resize');
	var background = $('body');
	var bodywidth = $(window).width();
	var bodyheight = $(window).height();
	var backgroundsize = bodywidth + 'px ' + bodyheight + 'px';
	background.css('background-size',backgroundsize);
}

function drawBackgroundFlag(team){
	var background = $('body');
	var bodywidth = $(window).width();
	var bodyheight = $(window).height();
	var backgroundsize = bodywidth + 'px ' + bodyheight + 'px';
	if(team === 'norway'){
		background.css('background','url("Images/norge.png") no-repeat center center fixed');
		background.css('background-size',backgroundsize);
	}
	else{
		background.css('background','url("Images/sverige.png") no-repeat center center fixed');
		background.css('background-size',backgroundsize);
	}
}


function showCharacterSelection(data){
	console.log(data);
  	$("#characterSelectionDiv").fadeIn(500, function() { $(this).css("display", "block"); });
  	drawSelectionSoldier(data);
  	drawSelectionHorse(data);
  	drawSelectionCanon(data);
}

function drawSelectionSoldier(data){
	if(data.maxSoldiers === 'x'){
		drawSelectionPlayerNoLimit("soldierSelection", selectionSoldierImage, 'soldier');
  	}
  	else{
		drawSelectionPlayer("soldierSelection", selectionSoldierImage, data.activeSoldiers, data.maxSoldiers, 'soldier');
  	}
}

function drawSelectionHorse(data){
	if(data.maxCavalery === 'x'){
		drawSelectionPlayerNoLimit("horseSelection", selectionHorseImage, 'horse');
  	}
  	else{
  		drawSelectionPlayer("horseSelection", selectionHorseImage, data.activeCavalery, data.maxCavalery, 'horse');
  	}
}

function drawSelectionCanon(data){
	if(data.maxCanons === 'x'){
		drawSelectionPlayerNoLimit("canonSelection", selectionCanonImage, 'canon');
  	}
  	else{
  		drawSelectionPlayer("canonSelection", selectionCanonImage, data.activeCanons, data.maxCanons, 'canon');	
  	}
}

function drawSelectionPlayerNoLimit(canvasName, imageName, socketEmitMsg){
	var oldcan = document.getElementById(canvasName);
	var can = oldcan.cloneNode(true);
	oldcan.parentNode.replaceChild(can, oldcan);
	var con = can.getContext('2d');
	can.width = can.width;
	var x = 0;
	var y = 0;
	con.globalAlpha = 1;

	con.beginPath();
    con.rect(x, y, can.width, can.height);
    con.fillStyle = 'gray';
    con.fill();
	
	con.drawImage(imageName, x + can.width / 2 - imageName.width / 2, y + can.height / 2 - imageName.height / 2);

	

	var click = function(e){
		e.preventDefault();
		console.log('character selected');
		socket.emit('characterSelected',socketEmitMsg);
		$("#characterSelectionDiv").fadeOut(500, function() { $(this).css("display", "none"); });
	}
	
	// can.removeEventListener("mousedown", click);
	can.addEventListener("mousedown", click);

	// can.removeEventListener("touchstart", click);
	can.addEventListener("touchstart", click);
}


function drawSelectionPlayer(canvasName, imageName, takenSpots, totalSpots, socketEmitMsg){
	var oldcan = document.getElementById(canvasName);
	var can = oldcan.cloneNode(true);
	oldcan.parentNode.replaceChild(can, oldcan);
	var con = can.getContext('2d');
	can.width = can.width;
	var x = 0;
	var y = 0;
	if(takenSpots > totalSpots - 1){
		con.globalAlpha = 0.3;
	}
	else{
		con.globalAlpha = 1;
	}

	con.beginPath();
    con.rect(x, y, can.width, can.height);
    con.fillStyle = 'gray';
    con.fill();
	
	con.drawImage(imageName, x + can.width / 2 - imageName.width / 2, y + can.height / 2 - imageName.height / 2);

	con.font        = "normal 12px Arial";
	con.fillStyle = 'black';
	con.fillText(takenSpots + "/" + totalSpots, x + 10, y + 20);

	var click = function(e){
		e.preventDefault();
		if(takenSpots < totalSpots){
			//console.log(socketEmitMsg);
			console.log('character selected');
			socket.emit('characterSelected',socketEmitMsg);
			$("#characterSelectionDiv").fadeOut(500, function() { $(this).css("display", "none"); });
		}
	}
	
	// can.removeEventListener("mousedown", click);
	can.addEventListener("mousedown", click);

	// can.removeEventListener("touchstart", click);
	can.addEventListener("touchstart", click);
}


var charac;

function setup(data){
	
	var context = controllerCanvas.getContext('2d');
	controllerCanvas.width = controllerCanvas.width;

	var gamepadImage = new Image();
	gamepadImage.onload = function() {
	  context.drawImage(gamepadImage, 0, 0);
	};
	gamepadImage.src = 'Images/gamepad.png';

	var context2 = fireCanvas.getContext('2d');
	fireCanvas.width = fireCanvas.width;

	var fireImage = new Image();
	fireImage.onload = function() {
	  context2.drawImage(fireImage, canvasWidth / 3, canvasHeight / 3, canvasWidth * 2 / 3, canvasHeight * 2 / 3);
	};

	var infoIcon = new Image();
	infoIcon.onload = function() {
	  context2.drawImage(infoIcon, 0, 0, canvasWidth / 3, canvasHeight / 3);
	};
	infoIcon.src = 'Images/helpIcon.png';

	charac = data.character;
	if(data.character === 'soldier'){
		fireImage.src = 'Images/musketIcon.png';
	}
	else if(data.character === 'horse'){
		fireImage.src = 'Images/horseIcon.png';
	}
	else{
		fireImage.src = 'Images/canonIcon.png';
	}
	
}


var keyPressed = false;
function setUpActionEvents(){
	//console.log('setting up events');
	document.body.ontouchstart = function(e) {
	    if (e && e.preventDefault) { e.preventDefault(); }
	    if (e && e.stopPropagation) { e.stopPropagation(); }
	    return false;
	}

	document.body.ontouchmove = function(e) {
	    if (e && e.preventDefault) { e.preventDefault(); }
	    if (e && e.stopPropagation) { e.stopPropagation(); }
	    return false;
	}

	document.body.onkeydown = function(e){
		//console.log('keydown');
		//e.preventDefault();
		if(keyPressed){
			return;
		}
		console.log(e.keyCode);
		keyPressed = true;
		if(e.keyCode === 39){
			//høyre piltast
			rightStart();
		}
		else if(e.keyCode === 40){
			//piltast ned
			downStart();
		}
		else if(e.keyCode === 37){
			//piltast venstre
			leftStart();
		}
		else if(e.keyCode === 38){
			//piltast opp
			upStart();
		}
		else if(e.keyCode === 32){
			//space
			fireStart();
		}
		else if(e.keyCode === 73){
			//i
			helpStart();
		}
		
	};
	document.body.onkeyup = function(e){
		//console.log('keyup');
		//e.preventDefault();
		console.log(e.keyCode);
		keyPressed = false;
		if(e.keyCode === 39 || e.keyCode === 40 || e.keyCode === 37 || e.keyCode === 38){
			//høyre piltast
			directionStop();
		}
		else if(e.keyCode === 32){
			//space
			fireStop();
		}
		else if(e.keyCode === 73){
			//i
			helpStop();
		}
	};

	actionEvents();
}

function keyboardDown(e){
	console.log('keyboardown');
	
}

function keyboardUp(e){
	console.log('keyboardup');
	
}


function touchFireStart(e){
	//console.log('fire start');
	e.preventDefault();
	var x = Math.floor((e.touches[0].pageX-fireCanvas.offsetLeft));
    var y = Math.floor((e.touches[0].pageY-fireCanvas.offsetTop));
    console.log('x: '+x+', y:'+y);

    if(x < canvasWidth / 3 && y < canvasHeight / 3){
		helpStart();
	}
	else {
		fireStart();
	}
}


function clickFireStart(e){
	//console.log('fire start');
	e.preventDefault();
	var x = Math.floor((e.pageX-fireCanvas.offsetLeft));
    var y = Math.floor((e.pageY-fireCanvas.offsetTop));
    console.log('x: '+x+', y:'+y);

    if(x < canvasWidth / 3 && y < canvasHeight / 3){
		helpStart();
	}
	else {
		fireStart();
	}
}


function touchStart(e){
	//console.log('touchstart');
	e.preventDefault();
	
	if(!horseIsActive){
		socket.emit('activateHorse');
		horseIsActive = true;
	}
	
	var x = Math.floor((e.touches[0].pageX-controllerCanvas.offsetLeft));
    var y = Math.floor((e.touches[0].pageY-controllerCanvas.offsetTop));
	//var x = e.changedTouches[0].pageX;
    //var y = e.changedTouches[0].pageY;
    
	findCorrectDirection(x,y);
}

function clickStart(e){
	//console.log('touchstart');
	e.preventDefault();
	
	if(!horseIsActive){
		socket.emit('activateHorse');
		horseIsActive = true;
	}
	
	var x = Math.floor((e.pageX-controllerCanvas.offsetLeft));
    var y = Math.floor((e.pageY-controllerCanvas.offsetTop));

    //console.log('x: '+x+', y:'+y);
    
    findCorrectDirection(x,y);
	
}

function findCorrectDirection(x, y){
	if(x > y && canvasHeight - y < x){
		rightStart();
	}
	else if(x < y && canvasHeight - y > x){
		leftStart();
	}
	else if(x < y && canvasHeight - y < x){
		downStart();
	}
	else if(x > y && canvasHeight - y > x){
		upStart();
	}
}


function touchEnd(e){
	//console.log('touchend');
	e.preventDefault();
	if(playerPressedFire){
		//console.log('firestop');
		fireStop();
	}
	else if(playerPressedHelp){
		helpStop();
	}
	else{
		//console.log('directionstop');
		directionStop();
	}
	playerPressedFire = false;
	playerPressedHelp = false;
}


function helpStart(){
	console.log('helpStart');
	playerPressedHelp = true;
	socket.emit('clientHelpStart');
}

function helpStop(){
	//console.log('helpStop');
	socket.emit('clientHelpStop');
}

function fireStart(){
	//console.log('fireStart');
	playerPressedFire = true;
	socket.emit('fireStart');
}

function fireStop(){
	//console.log('fireStop');
	socket.emit('fireStop');
	if(charac === 'soldier'){
		//musketSound.play();
	}
	else if(charac === 'horse'){
		//swordSound.play();
	}
	else{
		//canonFireSound.play();
	}
}

function directionStop(){
	socket.emit('controllerDirectionStop');
}

function leftStart(){
	socket.emit('controllerLeftStart');
}

function rightStart(){
	socket.emit('controllerRightStart');
}

function upStart(){
	socket.emit('controllerUpStart');
}

function downStart(){
	socket.emit('controllerDownStart');
}


var controllerCanvas = document.getElementById("clientController");
var fireCanvas = document.getElementById("clientButton");
var mainCanvas = document.getElementById("clientMain");
var horseIsActive = false;
var playerPressedFire = false;
var playerPressedHelp = false;
var canvasWidth = controllerCanvas.width;
var canvasHeight = controllerCanvas.height;
function actionEvents(){
	
    controllerCanvas.addEventListener("mousedown", clickStart, false);
    controllerCanvas.addEventListener("mouseup", touchEnd, false);
    //can.addEventListener("mousemove", mouseXY, false);
    controllerCanvas.addEventListener("touchstart", touchStart, false);
    //can.addEventListener("touchmove", touchXY, true);
    controllerCanvas.addEventListener("touchend", touchEnd, false);

    fireCanvas.addEventListener("mousedown", clickFireStart, false);
    fireCanvas.addEventListener("mouseup", touchEnd, false);
    fireCanvas.addEventListener("touchstart", touchFireStart, false);
    fireCanvas.addEventListener("touchend", touchEnd, false);
    
    
    mainCanvas.addEventListener("mouseup", touchEnd, false);
    mainCanvas.addEventListener("touchend", touchEnd, false);
    
}



