/*
*		Framework for Interactive GameWall Application
*				    UserApp Framework
*
*	Written by Aleksander Aanesland Elvemo and Vegard Gamnes
*					  Spring 2013
*/

//Socket connecting to Server
var socket;
//All default UserApp bindings must be defined in here
function addDefaultUserAppBindings(){
	addBinding(
		'connect', function(){
			socket.emit('verifyUserApp');
		}
	);
}
//Method for adding a function to a event
function addBinding(keyword, func){
	socket.on(keyword, func);
}
//Method for sending a message to the server
function sendEventToServer(event){
	socket.emit(event);
}
//Method for sending a message to the server
function sendDataToServer(event, data){
	socket.emit(event, data);
}
//Connect to a local server, using the URL bar
function connectToLocalServer(){
	socket = io.connect('http://'+location.host.substring(0,location.host.indexOf(':')));
	addDefaultUserAppBindings();
}
//Connect to a server, using a specific address
function connectToServer(address){
	socket = io.connect(address);
	addDefaultUserAppBindings();
}