$(document).ready(function(){
  
  connectToLocalServer();

/*
  addBinding('connect', function (data){
    console.log('Connected to server');
    sendDataToServer('verifyGameWallApp', 'gw');
    progress = 0;
    foreground.attr("d", arc.endAngle(twoPi * progress));
    text.text(formatPercent(progress));
  });
  */

  addBinding('update', function (data){
    console.log('update');
    progress = data.percent;
    foreground.attr("d", arc.endAngle(twoPi * progress));
    text.text(formatPercent(progress));

    textNumber.text(data.numberCompleted+'/'+data.numberTotal);
  });

  var qrurl = 'http://' + location.host + '/index.html';
  var qrImg = '<img id="qrcodeimg" src="http://qrickit.com/api/qr?d='+qrurl+'&addtext='+qrurl+'&txtcolor=442EFF&fgdcolor=000000&bgdcolor=FFFFFF&qrsize=150&t=p&e=m" onmouseover="showQRCode()" onmouseout="closeQRCode()">';
  $('#qrcode').prepend(qrImg);

});


function showQRCode(){
  console.log('qr code');
  var windowHeight = $(document).height();
  var windowWidth = $(document).width();
  var qrsize = Math.min(windowWidth,windowHeight,900);
  console.log('height: '+windowHeight+', width: '+windowWidth);
  $('#qrcodeimg').animate({
    opacity: 1,
    height: qrsize+'px',
    width: qrsize+'px'
  }, 1000, function() {
    // Animation complete.
  });
}

function closeQRCode(){
  $('#qrcodeimg').animate({
    opacity: 1,
    height: '150px',
    width: '150px'
  }, 1000, function() {
    // Animation complete.
  });
}

console.log(document.width);

var width = document.width,
    height = document.height,
    twoPi = 2 * Math.PI,
    progress = 0,
    total = 1308573, // must be hard-coded if server doesn't report Content-Length
    formatPercent = d3.format(".0%");


var length = Math.min(width, height) / 2;
var outerR = length - 50;
var innerR = outerR * 0.75;


var arc = d3.svg.arc()
    .startAngle(0)
    .innerRadius(innerR)
    .outerRadius(outerR);

var svg = d3.select("body").append("svg")
    .attr("width", width)
    .attr("height", height)
  .append("g")
    .attr("transform", "translate(" + width / 2 + "," + height / 2 + ")");

var meter = svg.append("g")
    .attr("class", "progress-meter");

meter.append("path")
    .attr("class", "background")
    .attr("d", arc.endAngle(twoPi));

var foreground = meter.append("path")
    .attr("class", "foreground");

var text = meter.append("text")
    .attr("text-anchor", "middle")
    .attr("class", "score")
    .attr("dy", ".05em");

var textNumber = meter.append("text")
    .attr("text-anchor", "middle")
    .attr("class", "numberOfStudents")
    .attr("dy", "2em");
textNumber.text('');

/*
d3.json("https://api.github.com/repos/mbostock/d3/git/blobs/2e0e3b6305fa10c1a89d1dfd6478b1fe7bc19c1e?" + Math.random())
    .on("progress", function() {
      var i = d3.interpolate(progress, d3.event.loaded / total);
      d3.transition().tween("progress", function() {
        return function(t) {
          progress = i(t);
          foreground.attr("d", arc.endAngle(twoPi * progress));
          text.text(formatPercent(progress));
        };
      });
    })
    .get(function(error, data) {
      meter.transition().delay(250).attr("transform", "scale(0)");
    });
    */





/*
var agg = { label: 'Aggressive', pct: [30, 20, 10, 5] },

    data = agg;

var labels = ['LCAP', 'Hwhwhw', 'jajaja', 'googo'];

var w = 320,                       // width and height, natch
    h = 320,
    r = Math.min(w, h) / 2,        // arc radius
    dur = 750,                     // duration, in milliseconds
    color = d3.scale.category10(),
    donut = d3.layout.pie().sort(null),
    arc = d3.svg.arc().innerRadius(r - 70).outerRadius(r - 20);

// ---------------------------------------------------------------------
var svg = d3.select("#d3portfolio").append("svg:svg")
    .attr("width", w).attr("height", h);

var arc_grp = svg.append("svg:g")
    .attr("class", "arcGrp")
    .attr("transform", "translate(" + (w / 2) + "," + (h / 2) + ")");

var label_group = svg.append("svg:g")
    .attr("class", "lblGroup")
    .attr("transform", "translate(" + (w / 2) + "," + (h / 2) + ")");

// GROUP FOR CENTER TEXT
var center_group = svg.append("svg:g")
    .attr("class", "ctrGroup")
    .attr("transform", "translate(" + (w / 2) + "," + (h / 2) + ")");

// CENTER LABEL
var pieLabel = center_group.append("svg:text")
    .attr("dy", ".35em").attr("class", "chartLabel")
    .attr("text-anchor", "middle")
    .text(data.label);

// DRAW ARC PATHS
var arcs = arc_grp.selectAll("path")
    .data(donut(data.pct));
arcs.enter().append("svg:path")
    .attr("stroke", "white")
    .attr("stroke-width", 0.5)
    .attr("fill", function(d, i) {return color(i);})
    .attr("d", arc)
    .each(function(d) {this._current = d});

// DRAW SLICE LABELS
var sliceLabel = label_group.selectAll("text")
    .data(donut(data.pct));
sliceLabel.enter().append("svg:text")
    .attr("class", "arcLabel")
    .attr("transform", function(d) {return "translate(" + arc.centroid(d) + ")"; })
    .attr("text-anchor", "middle")
    .text(function(d, i) {return labels[i]; });

// --------- "PAY NO ATTENTION TO THE MAN BEHIND THE CURTAIN" ---------

// Store the currently-displayed angles in this._current.
// Then, interpolate from this._current to the new angles.
function arcTween(a) {
    var i = d3.interpolate(this._current, a);
    this._current = i(0);
    return function(t) {
        return arc(i(t));
    };
}

// update chart
function updateChart(model) {
    data = model; // which model?

    arcs.data(donut(data.pct)); // recompute angles, rebind data
    arcs.transition().ease("elastic").duration(dur).attrTween("d", arcTween);

    sliceLabel.data(donut(data.pct));
    sliceLabel.transition().ease("elastic").duration(dur)
        .attr("transform", function(d) {return "translate(" + arc.centroid(d) + ")"; })
        .style("fill-opacity", function(d) {return d.value==0 ? 1e-6 : 1;});
        
    pieLabel.text(data.label);
}

setInterval(function(){
  agg.pct[0] += 5;
  updateChart(agg);
}, 1000);
*/
/*

// simple array
var data = [8, 12, 15, 30, 43];
var dataLabel = ['Question 1', 'Question 2', 'Question 3', 'Question 4', 'Question 5'];
var colorScale = d3.scale.linear()
    .domain([d3.min(data), d3.max(data)])
    //.interpolate(d3.interpolateHsl)
    //.interpolate(d3.interpolateLab)
    .interpolate(d3.interpolateHcl)
    .range(["#007AFF", "#FFF500"]);


// variables for chart width and height
var w = 100,
    h = 400;

var chart = d3.select("#chart").append("svg")
    .attr("class", "chart")
    .attr("width", w * data.length)
    .attr("height", h);

var x = d3.scale.linear()
    .domain([0, 1])
    .range([0, w]);
     
var y = d3.scale.linear()
    .domain([0, 50])
    .rangeRound([0, h]); //rangeRound is used for antialiasing

    // x and y are the lower-left position of the bar
// width is the width of the bar
// height is the height of the bar
// for crisp edges use -.5 (antialiasing)
chart.selectAll("rect")
    .data(data)
  .enter().append("rect")
    .attr("x", function(d, i) { return x(i) - .5 + 5; })
    .attr("y", function(d) { return h + 15; })
    .attr("width", w - 10)
    .attr("height", 0)
    .attr("fill", function(d,i) {
      return colorScale(d);
    });
     

    // horizontal line for the x-axis
chart.append("line")
     .data(x.ticks(10))
     .attr("x1", 0)
     .attr("x2", w * data.length)
     .attr("y1", h - .5)
     .attr("y2", h - .5)
     .style("stroke", "#000");

chart.append("line")
     .data(y.ticks(10))
     .attr("x1", 0)
     .attr("x2", 0)
     .attr("y1", h - .5)
     .attr("y2", 0 - .5)
     .style("stroke", "#000");

 var labels = chart.append("g")
            .attr("class", "labels")
            .selectAll("text")
            .data(dataLabel)
            .enter()
            .append("text")
            .attr("x", function(d, i) { return x(i); })
            .attr("y", function(d) { return h - 10; })
            .text(function(d) {
                return d;
            });

setInterval(function(){
  data[0] += 2;
  updateChart();
}, 1000);

function updateChart(){
  console.log('Updating chart');

  chart.selectAll("rect").data(data).transition().attr("y", function(d) { return h - y(d) - .5; }).attr("height", function(d) { return y(d); }).ease("elastic");
}

*/
