var Framework = require("../Framework/FIGAServer.js");


function CategoriesApp() {

    this.password = require('../password.json');

    this.init = function() {
        CategoriesApp.prototype.init(__dirname);
    }
}
CategoriesApp.prototype = new Framework.GameWallServer;
var server = new CategoriesApp();

var currentQuestion = 0;

/*
var questions = [
  {
    header1: 'Architectural',
    list1: [],
    header2: 'Non-architectural',
    list2: [],
    headerSource: 'Sort!',
    listSource: ['Look and feel', 'Quality attributes', 'Programming language', 'Coding techniques', 'Reuse of data', 'Software structure', 'Layers', 'Algorithms', 'Code conversion', 'Component interaction', 'Architectural patterns'],
    categoryAnswer: {
      list1: ['Software structure', 'Architectural patterns', 'Quality attributes', 'Component interaction', 'Reuse of data', 'Layers'],
      list2: ['Algorithms', 'Look and feel', 'Programming language', 'Coding techniques', 'Code conversion'],
      listSource: []
    }
  }
];*/

var questions = [
  {
    header1: 'Cloud',
    list1: [],
    header2: 'Not Cloud',
    list2: [],
    headerSource: 'Sort!',
    listSource: ['FAT File System', 'Improved Scalability', 'Fixed IP-Addresses', 'Improved Utilization', 'Heterogeneous Clients', 'Single-Point of Failure', 'Support Multi-Tenancy', 'Redundancy', 'Location-Dependent', 'Fixed Capacity', 'Private Hardware', 'HDFS File System'],
    categoryAnswer: {
      list1: ['Improved Scalability', 'Improved Utilization', 'Heterogeneous Clients', 'Support Multi-Tenancy', 'HDFS File System', 'Redundancy'],
      list2: ['Location-Dependent', 'Fixed Capacity', 'Private Hardware', 'Fixed IP-Addresses', 'FAT File System', 'Single-Point of Failure'],
      listSource: []
    }
  }
];

/////////////////////////////////////////////////
//////         Add triggers here          ///////
/////////////////////////////////////////////////

server.addChannelBinding('verifyUserApp', 'all',
  function() {
    if(server.dataObjectIsEmpty(this.info)){
      //New Connection
      console.log('New Client Connection');
      this.info = {};    }else{
      //Old Connection
      console.log('ReSynced Client Connection');
      // console.log(this.info.yolo);
    }
    var question = questions[currentQuestion];
    this.emit('setup', question);
    this.completed = false;
    checkNumberOfCompletedStudents();
  }
);

server.addChannelBinding('verifyGameWallApp', 'all',
  function() {
    if(server.dataObjectIsEmpty(this.info)){
      //New Connection
      console.log('New GameWall Connection');
      this.info = {};
    }else{
      //Old Connection
      console.log('ReSynced GameWall Connection');
      // console.log(this.info.yolo);
    }
    checkNumberOfCompletedStudents();
  }
);

server.addChannelBinding('check', 'all',
  function(data) {
    checkAnswer(this, data);
  }
);

server.addChannelBinding('password', 'all',
  function(pswd) {
    if(pswd == server.password.password){
      server.sendDataToSocket(this, 'passwordAcc', { accepted:true });
    }else{
      console.log('Someone tried to connect to the server with wrong password');
      console.log(this.handshake.address);
      server.sendDataToSocket(this, 'passwordAcc', { accepted:false });
    }
  }
);

server.addChannelBinding('prevQ', 'all',
  function() {
    // console.log('Received prevQ');
    currentQuestion--;
    if(currentQuestion < 0){
      currentQuestion = 0;
    }
    var question = questions[currentQuestion];
    server.getUserAppsConnected().forEach(function (socket) {
      socket.completed = false;
      socket.emit('setup', question);
    });
    server.sendDataToChannel('update', {percent:0,numberCompleted:0,numberTotal:server.getUserAppsConnected().length}, 'gamewallApps');
    // server.sendDataToChannel('update', 0, 'gamewalls');
  }
);

server.addChannelBinding('nextQ', 'all',
  function() {
    // console.log('Received nextQ');
    currentQuestion++;
    if(currentQuestion <= questions.length-1){
      var question = questions[currentQuestion];
      server.getUserAppsConnected().forEach(function (socket) {
        socket.completed = false;
        socket.emit('setup', question);
      });
      server.sendDataToChannel('update', {percent:0,numberCompleted:0,numberTotal:server.getUserAppsConnected().length}, 'gamewallApps');
      // server.sendDataToChannel('update', 0, 'gamewalls');
    }else{
      // console.log('No more questions!');
      currentQuestion = questions.length-1;
    }
  }
);

function checkAnswer(socket, answer){
  var clientAnswerList1 = answer.list1;
  var clientAnswerList2 = answer.list2;
  var clientAnswerSource = answer.listSource;

  var correctAnswerList1 = questions[currentQuestion].categoryAnswer.list1;
  var correctAnswerList2 = questions[currentQuestion].categoryAnswer.list2;
  var correctAnswerSource = questions[currentQuestion].categoryAnswer.listSource;

  var totalAnswers = clientAnswerList1.length + clientAnswerList2.length + clientAnswerSource.length;
  var currentCorrect = 0;

  for(var i = 0; i < clientAnswerList1.length; i++){
    if(contains(clientAnswerList1[i], correctAnswerList1)){
      // console.log(answerList1[i] + ' is contained in list1');
      currentCorrect++;
    }
  }
  for(var i = 0; i < clientAnswerList2.length; i++){
    if(contains(clientAnswerList2[i], correctAnswerList2)){
      // console.log(answerList2[i] + ' is contained in list2');
      currentCorrect++;
    }
  }
  for(var i = 0; i < correctAnswerSource.length; i++){
    if(contains(correctAnswerSource[i], clientAnswerSource)){
      // console.log(answerSource[i] + ' is contained in listSource');
      currentCorrect++;
    }
  }

  console.log('The user answered ' + currentCorrect + '/' + totalAnswers + ' correctly');

  if(currentCorrect === totalAnswers){
    socket.completed = true;
    socket.emit('done');
  }
  checkNumberOfCompletedStudents();
}

function checkNumberOfCompletedStudents(){
  var numberOfCompletedStudents = 0;
  var numberOfStudents = 0;
  server.getUserAppsConnected().forEach(function (socket) {
    numberOfStudents++;
    if(socket.completed){
      numberOfCompletedStudents++;
    }
  });
  //numberOfStudents = 78;
  //numberOfCompletedStudents = 23;
  console.log('Number of students ' + numberOfStudents + ' coompleted ' + numberOfCompletedStudents);
  var completedPercent = numberOfCompletedStudents / numberOfStudents;

  if(numberOfStudents == 0){
    completedPercent = 0;
  }

  server.sendDataToChannel('update', {percent:completedPercent,numberCompleted:numberOfCompletedStudents,numberTotal:numberOfStudents}, 'gamewallApps');
 
  if(numberOfCompletedStudents == numberOfStudents && numberOfStudents > 0){
    //Next question!
    setupNextQuestion();
  }
}

function setupNextQuestion(){
  currentQuestion++;
  if(currentQuestion <= questions.length-1){
    var question = questions[currentQuestion];
    server.getUserAppsConnected().forEach(function (socket) {
      socket.completed = false;
      socket.emit('setup', question);
    });

    server.sendDataToChannel('update', {percent:0,numberCompleted:0,numberTotal:server.getUserAppsConnected().length}, 'gamewallApps');
  }else{
    console.log('No more questions!');
  }
}

function contains(value, array){
  for(var i =0; i < array.length; i++){
    if(array[i] === value){
      return true;
    }
  }
  return false;
}


server.init();



