$(document).ready(function(){
    connectToLocalServer();

    addBinding('setup', function (data){
        var header1 = data.header1;
        var list1 = data.list1;
        var header2 = data.header2;
        var list2 = data.list2;
        var headerSource = data.headerSource;
        var listSource = data.listSource;
        createCategoryLists(header1, list1, header2, list2, headerSource, listSource);
    });

    addBinding('done', function (data){
        alert("All items categorized correctly! :)");

        $( "#sortableSource" ).sortable( "disable" );
        $( "#sortable1" ).sortable( "disable" );
        $( "#sortable2" ).sortable( "disable" );
    });

    $( "#sortable1, #sortable2, #sortableSource" ).sortable({
      connectWith: ".connectedSortable"
    }).disableSelection();

    var button = $('#button');
    button.bind('click', function() {
        sendResults();
    });  

    $( "#sortableSource" ).sortable({
      remove: function( event, ui ) { checkIfDone(); }
    });

    $( "#sortable1" ).sortable({
      remove: function( event, ui ) { checkIfDone(); }
    });

    $( "#sortable2" ).sortable({
      remove: function( event, ui ) { checkIfDone(); }
    });
});

function checkIfDone(){
    var numberInSource = 0;

    $("#sortableSource li").each(function( index ) {
      numberInSource++;
    });

    console.log('Current in source ' + numberInSource);
    if(numberInSource == 0){
        sendResults();
    }
}

function sendResults(){
    console.log('Sjekker resultater');

    var result = {
        list1: [],
        list2: [],
        listSource: []
    }

    $("#sortable1 li").each(function( index ) {
      var text = this.innerHTML;
      result.list1.push(text);
    });

    $("#sortable2 li").each(function( index ) {
      var text = this.innerHTML;
      result.list2.push(text);
    });

    $("#sortableSource li").each(function( index ) {
      var text = this.innerHTML;
      result.listSource.push(text);
    });

    sendDataToServer('check', result);
}

function showTryAgain(){
    console.log('try again');
    var container = $('#container');
    container.append('<div id="clientPostit"></div>');
    var postit = $('#clientPostit');

    var viewportWidth = $(window).width();
    var viewportHeight = $(window).height();

    var postitWidth = viewportWidth - 50;
    if(postitWidth > 400){
        postitWidth = 400;
    }
    var postitHeight = postitWidth;

    var left = (viewportWidth - postitWidth) / 2;

    postit.height(postitHeight);
    postit.width(postitWidth);
    

    var inputWidth = postitWidth - 10;
    var inputHeight = postitHeight - 75;

    var string = '<p>Try again later..</p>';
    postit.append(string);
}

function createCategoryLists(header1Txt, list1, header2Txt, list2, headerSourceTxt, listSource){
    var header1 = $('#list1Header');
    var list1Obj = $('#sortable1');
    var header2 = $('#list2Header');
    var list2Obj = $('#sortable2');
    var headerSource = $('#listSource');
    var listSourceObj = $('#sortableSource');

    header1.html(header1Txt);
    list1Obj.html('');
    createListFromArray(list1Obj, list1);

    header2.html(header2Txt);
    list2Obj.html('');
    createListFromArray(list2Obj, list2);

    headerSource.html(headerSourceTxt);
    listSourceObj.html('');
    createListFromArray(listSourceObj, listSource);

    $( "#sortableSource" ).sortable( "enable" );
    $( "#sortable1" ).sortable( "enable" );
    $( "#sortable2" ).sortable( "enable" );
}

function createListFromArray(listObject, array){
    for (var i =0; i < array.length; i++) {
        var text = array[i];
        listObject.append("<li>" + text + "</li>");
    }
}