var canvas;

var categoryColorChosen = 'gray';

$(document).ready(function(){
  
  $('#wordList').sortable({
    zIndex: 0
  });

  canvas = document.getElementById('canvas');

  connectToLocalServer();

  addBinding('connect', function (data){
    $("#categoryDiv").fadeOut(500, function() { $(this).css("display", "none"); });
    $("#qrcode").fadeOut(500, function() { $(this).css("display", "none"); });
    $("#passwordDiv").fadeIn(500, function() { $(this).css("display", "block"); });
  });

  addBinding('passwordAcc', function (data){
    console.log('Verifyacc ' + data.accepted);
    if(data.accepted){
      sendDataToServer('gamewall', 'gw');
    }else{
      console.log('Wrong password, will not connect to server');
    }
  });

  addBinding('word', function (data){
    handleMessage(data);
  });

  addBinding('history', function (data){
    for(var i = 0; i < data.words.length; i++){
      handleMessage(data.words[i]); 
    }
    for(var i = 0; i < data.categories.length; i++){
      handleCategory(data.categories[i]); 
    }
  });

  addBinding('remove', function (data){
    removeWordFromList(data);
  });
  

  addBinding('category', function (data){
    addCategoryToList(data);
  });

  addBinding('removeCategory', function (data){
    removeCategoryFromList(data);
  });

  addBinding('updateColor', function (data){
    $("#wordList li").each(function( index ) {
      if($(this).text() === data.name){
        $(this).css('background-color',data.color);
      }
    });
  });

  var qrurl = 'http://' + location.host + '/index.html';
  var qrImg = '<img id="qrcodeimg" src="http://qrickit.com/api/qr?d='+qrurl+'&addtext='+qrurl+'&txtcolor=442EFF&fgdcolor=000000&bgdcolor=FFFFFF&qrsize=150&t=p&e=m" onmouseover="showQRCode()" onmouseout="closeQRCode()">';
  $('#qrcode').prepend(qrImg);

  $('#pass').keypress(function(e) {
    if(e.which == 13) {
      e.preventDefault();
      checkPassword();
    }
  });

  var button = $('#categorySubmit');
  var input = $('#input');
  button.bind('click', function() {
    closeAddCategory();
    console.log('Pressing submit');
    var msg = $(input).val();
    if(!msg){
        return;
    }

    var color = 'gray';

    $("#categoryDivOptions div").each(function( index ) {
      //console.log( index + ": " + $(this).text() );
      if($(this).hasClass('categoryColorSelected')){
        color = $(this).css('background-color');
      }
    });
    
    input.val('');
    console.log('Sending msg ' + msg);
    sendDataToServer('newCategory', {name: msg, color: color});
  });

  $("#categoryDivOptions div").each(function( index ) {
    $(this).bind('click', function() {
      categoryColorSelection($(this));
    });
  });
});

function checkPassword(){
  $("#passwordDiv").fadeOut(500, function() { $(this).css("display", "none"); });
  $("#categoryDiv").fadeIn(500, function() { $(this).css("display", "block"); });
  $("#qrcode").fadeIn(500, function() { $(this).css("display", "block"); });
  var pswd = $("#pass").val();
  sendDataToServer('password', {password:pswd});
}

function showQRCode(){
  console.log('qr code');
  var windowHeight = $(document).height();
  var windowWidth = $(document).width();
  var qrsize = Math.min(windowWidth,windowHeight,900);
  console.log('height: '+windowHeight+', width: '+windowWidth);
  $('#qrcodeimg').animate({
    opacity: 1,
    height: qrsize+'px',
    width: qrsize+'px'
  }, 1000, function() {
    // Animation complete.
  });
}

function closeQRCode(){
  $('#qrcodeimg').animate({
    opacity: 1,
    height: '150px',
    width: '150px'
  }, 1000, function() {
    // Animation complete.
  });
}


function categoryColorSelection(category){
  //console.log('category clicked');
  $("#categoryDivOptions div").each(function( index ) {
    //console.log( index + ": " + $(this).text() );
    $(this).removeClass('categoryColorSelected');
  });
  $(category).addClass('categoryColorSelected');
}


function addCategoryToList(data){
  console.log('adding category to list');
  //console.log(data.name);
  var deleteButton = $('<img src="deleteButton.png">');
  deleteButton.bind('click', function(e) {
    //alert('User clicked on "foo."');
    e.stopPropagation();
    //remove word from list
    sendDataToServer('removeCategory', data.name);
  });

  var newCategory = $('<li><div style="background-color:'+data.color+'; width: 50px; height: 50px"></div><div class="categoryName">'+data.name+'</div></li>');
  newCategory.prepend(deleteButton);
  $("#categoryList").append(newCategory);

  newCategory.bind('click', function() {
    //alert('User clicked on "foo."');
    $("#categoryList li").each(function( index ) {
      //console.log( index + ": " + $(this).text() );
      $(this).removeClass('categoryMarked');
    });
    $(this).addClass('categoryMarked');
    categoryColorChosen = data.color;
  });

  $("#categoryList li").each(function( index ) {
    //console.log( index + ": " + $(this).text() );
    $(this).removeClass('categoryMarked');
  });
  newCategory.addClass('categoryMarked');

  categoryColorChosen = data.color;
}


function removeSpacesFromMessage(message){
  return message;
  return message.replace(/\s/g,'');
}

function removeWordFromList(data){
  $("#wordList li").each(function( index ) {
    //console.log( index + ": " + $(this).text() );
    if($(this).text() === data){
      $(this).fadeOut(500, function() { $(this).remove(); });
    }
  });
}

function removeCategoryFromList(data){
  console.log('Removing category');
  $("#categoryList li").each(function( index ) {
    //console.log( index + ": " + $(this).text() );
    if($(this).text() === data){
      $(this).fadeOut(500, function() { 

        $(this).remove();
        var color = '#ffc';
        console.log('Removed category');
        if($('#categoryList').children('li').length > 0){
          $("#categoryList li").each(function( index ) {
            //console.log( index + ": " + $(this).text() );
            $(this).removeClass('categoryMarked');
          });
        
          var listElement = $($('#categoryList li').find('div').get(0));
          $($('#categoryList').find('li').get(0)).addClass('categoryMarked');
          color = listElement.css('background-color');
        }else{
          console.log('Empty list');
        }
        console.log('Color: ' + color);
        categoryColorChosen = color;
      });
    }
  });
}

function handleMessage(data){
  createNewWord(data);
}

function handleCategory(data){
  addCategoryToList(data);
}




function createNewWord(data){
  //console.log('creating new word');

  var deleteButton = $('<img src="deleteButton.png">');
  var listElement = $('<li><p>'+data.name+'</p></li>');
  console.log('Adding: ' + data.name + ' with color ' + data.color);
  listElement.css('background-color',data.color);


  deleteButton.bind('click', function(e) {
    e.stopPropagation();
    sendDataToServer('removeWord', data.name);
  });

  

  listElement.bind('click', function() {
    var color = categoryColorChosen;
    $(this).css('background-color',color);
    sendDataToServer('setColor', {name: data.name, color: color});
  });

  listElement.prepend(deleteButton);

  $("#wordList").append(listElement.fadeIn(1500));

}


function addCategory(){
  $("#categoryCreator").fadeIn(500, function() { $(this).css("display", "block"); });
  $("#categoryDiv").fadeOut(500, function() { $(this).css("display", "none"); });
}

function sortCategories(){
  console.log('Sorting');
  $("#categoryList li").each(function( index ) {
    var categoryColor = $($(this).find('div').get(0)).css('background-color');
    console.log(categoryColor);
    $("#wordList li").each(function( index ) {
      console.log(this);
      var wordColor = $(this).css('background-color');
      console.log(wordColor);
      if(categoryColor === wordColor){
        $(this).appendTo($("#wordList"));
      }
    });
  });
}

function closeAddCategory(){
  $("#categoryDiv").fadeIn(500, function() { $(this).css("display", "block"); });
  $("#categoryCreator").fadeOut(500, function() { $(this).css("display", "none"); });
}
