var Framework = require("../Framework/FIGAServer.js");

function PostItWall() {

    this.password = require('../password.json');
    this.words = [];
    this.categories = [];
    
    this.init = function() {
        PostItWall.prototype.init(__dirname);
        console.log('PostItWall init');
    }
}
PostItWall.prototype = new Framework.GameWallServer;

var server = new PostItWall();

/////////////////////////////////////////////////
//////         Add triggers here          ///////
/////////////////////////////////////////////////


server.addChannelBinding('newWord', 'userApp',
  function(word) {
    var newWord = true;
    for(var i = 0; i < server.words.length; i++){
      var serverWord = server.words[i];
      if(serverWord.name === word){
        newWord = false;
        break;
      }
    }
    if(newWord){
      console.log('Received word ' + word + ', sending it to gamewalls');
      var w = {name: word, color: '#ffc'}
      server.words.push(w);
      server.sendDataToChannel('word', w, 'gamewallApps');
    }
  }
);

server.addChannelBinding('removeWord', 'gamewallApp',
  function(word) {
    console.log('remove word');
    for(var i = 0; i < server.words.length; i++){
      var serverWord = server.words[i];
      console.log(serverWord + ' = '+word);
      if(serverWord.name === word){
        console.log('found word');
        server.words.splice(i, 1);
        server.sendDataToChannel('remove', word, 'gamewallApps');
        break;
      }
    }
  }
);

server.addChannelBinding('removeCategory', 'gamewallApp',
  function(category) {
    console.log('remove category ' + category);
    for(var i = 0; i < server.categories.length; i++){
      var serverCategory = server.categories[i];
      console.log(serverCategory + ' = '+category);
      if(serverCategory.name === category){
        console.log('found category');
        server.categories.splice(i, 1);
        server.sendDataToChannel('removeCategory', category, 'gamewallApps');
        break;
      }
    }
  }
);

server.addChannelBinding('setColor', 'gamewallApp',
  function(wordObject) {
    console.log('setcolor to word');
    for(var i = 0; i < server.words.length; i++){
      var serverWord = server.words[i];
      console.log(serverWord.name + ' = ' + wordObject.name);
      if(serverWord.name === wordObject.name){
        console.log('found word');
        serverWord.color = wordObject.color;
        server.sendDataToChannel('updateColor', wordObject, 'gamewallApps');
        break;
      }
    }
  }
);

server.addChannelBinding('password', 'all',
  function(psw) {
    if(psw.password == server.password.password){
      // console.log('Correct password! Accept');
      applicationIsReady = true;
      server.sendDataToSocket(this, 'passwordAcc', { accepted:true });
    }else{
      console.log('Someone tried to connect to the server ');
      console.log(this.handshake.address);
      server.sendDataToSocket(this, 'passwordAcc', { accepted:false });
    }
  }
);

var applicationIsReady = false;



server.addChannelBinding('verifyUserApp', 'all',
  function() {
    server.sendDataToSocket(this, 'setup', applicationIsReady);
  }
);

//GameWall connects override
server.addChannelBinding('gamewallView', 'all',
  function() {
    //server.bindSocket(this, 'gamewall');
    //this.join('gamewalls');
    //console.log('sending history');
    server.sendDataToSocket(this, 'history', {words:server.words, categories: server.categories});
  }
);

server.addChannelBinding('gamewall', 'all',
  function() {
    //server.bindSocket(this, 'gamewall');
    //this.join('gamewalls');
    //console.log('sending history');
    server.sendDataToSocket(this, 'history', {words:server.words, categories: server.categories});
  }
);

server.addChannelBinding('newCategory', 'gamewallApp',
  function(category) { 
    //Using the format: { name: 'Paris', color: '#FFFFFF'}
    var newCategory = true;
    //console.log('length: '+server.categories.length);
    for(var i = 0; i < server.categories.length; i++){
      console.log(server.categories[i]);
      var serverCategory = server.categories[i];
      if(serverCategory.name === category.name){
        newCategory = false;
        break;
      }
    }
    if(newCategory){
      //console.log('new category');
      server.categories.push(category);
      server.sendDataToSocket(this, 'category', category);
    }
  }
);

server.addChannelBinding('removeCategory', 'gamewallApp',
  function(category) { 
    //Using the format: { name: 'Paris', color: '#FFFFFF'}
    for(var i = 0; i < server.categories.length; i++){
      var serverCategory = server.categories[i];
      if(serverCategory === category.name){
        server.words.splice(i, 1);
        server.sendDataToChannel('removeCategory', category, 'gamewallApps');
        break;
      }
    }
  }
);

/////////////////////////////////////////////////
//////             Init server            ///////
/////////////////////////////////////////////////

server.init();