$(document).ready(function(){
    
    connectToLocalServer();

    addBinding('setup', function (data){
            console.log(data);
            if(data){
                createPostit();
                createBindings();
                sendMsgToServer('client');
            }
            else{
                showTryAgain();
            }
    });
});

function createBindings(){
    var content = $('#content');
    var input = $('#input');
    var button = $('#button');
    var status = $('#status');
    button.bind('click', function() {
        console.log('Pressing submit');
        var msg = $(input).val();
        if(!msg){
            return;
        }
        console.log('Sending msg ' + msg);
        sendDataToServer('newWord', msg);
        input.val('');
      });      
    
    //send message when user presses enter key
    input.keydown(function(e){
        if(e.keyCode === 13){
            var msg = $(this).val();
            if(!msg){
                return;
            }
            console.log('Sending msg ' + msg);
            sendDataToServer('newWord', msg);
            $(this).val('');
            e.preventDefault();
            //disable the input field to make the user wait until server sends back response
            //input.attr('disabled', 'disabled');
        }
    });
}

function showTryAgain(){
    console.log('try again');
    var container = $('#container');
    container.append('<div id="clientPostit"></div>');
    var postit = $('#clientPostit');

    var viewportWidth = $(window).width();
    var viewportHeight = $(window).height();

    var postitWidth = viewportWidth - 50;
    if(postitWidth > 400){
        postitWidth = 400;
    }
    var postitHeight = postitWidth;

    var left = (viewportWidth - postitWidth) / 2;

    postit.height(postitHeight);
    postit.width(postitWidth);
    
    var inputWidth = postitWidth - 10;
    var inputHeight = postitHeight - 75;

    var string = '<p>Prøv igjen senere..</p>';
    postit.append(string);
}

function createPostit(){
    console.log('Creating postit');
    var container = $('#container');
    container.append('<div id="clientPostit"></div>');
    var postit = $('#clientPostit');
    var string = '<form id="form"><input type="text" id="input" placeholder="<Enter Text>" maxlength="30" /></form><br><div id="button" class="submitButton">Submit</div>';
    postit.append(string);
}