var Framework = require("../Framework/FIGAServer.js");


function WordcloudApp() {

    this.password = require('../password.json');

    this.init = function() {
        WordcloudApp.prototype.init(__dirname);
    }
}
WordcloudApp.prototype = new Framework.GameWallServer;
var server = new WordcloudApp();



server.addChannelBinding('verifyUserApp', 'all',
  function() {
    if(server.dataObjectIsEmpty(this.info)){
      //New Connection
      console.log('New Client Connection');
      this.info = {};
    }else{
      //Old Connection
      console.log('ReSynced Client Connection');
      // console.log(this.info.yolo);
    }
    this.emit('setup');
  }
);

server.addChannelBinding('verifyGameWallApp', 'all',
  function() {
    if(server.dataObjectIsEmpty(this.info)){
      //New Connection
      console.log('New GameWall Connection');
      this.info = {};
    }else{
      //Old Connection
      console.log('ReSynced GameWall Connection');
      // console.log(this.info.yolo);
    }
    this.emit('history', words);
  }
);


server.addChannelBinding('password', 'all',
  function(pswd) {
    console.log(pswd);
    if(pswd == server.password.password){
      server.sendDataToSocket(this, 'passwordAcc', { accepted:true });
    }else{
      console.log('Someone tried to connect to the server with wrong password');
      console.log(this.handshake.address);
      server.sendDataToSocket(this, 'passwordAcc', { accepted:false });
    }
  }
);


server.addChannelBinding('delete', 'all',
  function(data) {
    // console.log('Received prevQ');
    var words = data.msg.split(" ");
    for(var i = 0; i < words.length; i++){
      deleteWord(words[i]);
    }
  }
);

server.addChannelBinding('message', 'all',
  function(data) {
    // console.log('Received prevQ');
    var words = data.msg.split(" ");
    for(var i = 0; i < words.length; i++){
      handleMessage(words[i]);
    }
  }
);








// used words
var words = [];

/**
 * Helper function for escaping input strings
 */
function htmlEntities(str) {
    return String(str).replace(/&/g, '&amp;').replace(/</g, '&lt;')
                      .replace(/>/g, '&gt;').replace(/"/g, '&quot;');
}



var wordID = 0;

function deleteWord(word){
  console.log('deleting word ' + word);

  var obj = {
      text: word,
      numberMentioned: 1,
      id: wordID
  };

  if(words.length === 0){
    return;
  }
  else{
    for(var i = 0; i < words.length; i++){
      if(words[i].text === obj.text){
        // console.log('Found word. Number: ' + words[i].numberMentioned);
        //io.sockets.in('gamewalls').emit('deleteWord', words[i]);
        server.sendDataToChannel('deleteWord', words[i], 'gamewallApps');
        words.splice(i,1);
        break;
      }
    }
  }
}


function handleMessage(word){
  console.log('Getting word ' + word);

  var obj = {
      text: word,
      numberMentioned: 1,
      id: wordID
  };

  var broadcastObj;
  if(words.length === 0){
    words.push(obj);
    broadcastObj = obj;
    wordID++;
  }
  else{
    var foundWord = false;
    for(var i = 0; i < words.length; i++){
      if(words[i].text === obj.text){
        foundWord = true;
        words[i].numberMentioned += 1;
        // console.log('Found word. Number: ' + words[i].numberMentioned);
        broadcastObj = words[i];
        break;
      }
    }
    if(!foundWord){
      // console.log("adding word to list");
      words.push(obj);
      broadcastObj = obj;
      wordID++;
    }
  }

  //io.sockets.in('gamewalls').emit('word', broadcastObj);
  server.sendDataToChannel('word', broadcastObj, 'gamewallApps');
}





server.init();

