$(document).ready(function(){
    
    //for better performance - to avoid searching in DOM
    var content = $('#content');
    var input = $('#input');
    var status = $('#status');
    var button = $('#button');
    
    
    connectToLocalServer();

    addBinding('setup', function (data){
        status.text('');
        input.removeAttr('disabled').focus();
    });

    button.click(function() {
        console.log('Pressing submit');
        var msg = $(input).val();
        if(!msg){
            return;
        }
        console.log('Sending msg ' + msg);
        sendDataToServer('message', {msg:msg});
        input.val('');
    });
    
    //send message when user presses enter key
    input.keydown(function(e){
        if(e.keyCode === 13){
            var msg = $(this).val();
            if(!msg){
                return;
            }
            //send message as an ordinary text
            sendDataToServer('message', {msg: msg});
            $(this).val('');
            //disable the input field to make the user wait until server sends back response
            //input.attr('disabled', 'disabled');
        }
    });
});