$(document).ready(function(){
    var inputPass = $('#pass');
    inputPass.keydown(function(e){
        if(e.keyCode === 13){
            e.preventDefault();
            checkPassword();
        }
    });
  
  connectToLocalServer();

  addBinding('setup', function (data){
      $("#passwordDiv").fadeIn(500, function() { $(this).css("display", "block"); });
  });

  socket.on('passwordAcc', function (response) {
    console.log(response);
    if(response.accepted){
      updateView();
      $("#content").fadeIn(500, function() { $(this).css("display", "block"); });
    }
  });
});



function updateView(){
    var input = $('#input');
    var status = $('#status');
    var button = $('#button');
    status.text('');
    input.removeAttr('disabled').focus();
    button.bind('click', function() {
        console.log('Pressing submit');
        var msg = $(input).val();
        if(!msg){
            return;
        }
        console.log('Sending msg ' + msg);
        sendDataToServer('delete', {msg:msg});
        input.val('');
      }); 
    
    //send message when user presses enter key
    input.keydown(function(e){
        if(e.keyCode === 13){
            e.preventDefault();
            var msg = $(this).val();
            if(!msg){
                return;
            }
            //send message as an ordinary text
            sendDataToServer('delete', {msg:msg});
            $(this).val('');
            //disable the input field to make the user wait until server sends back response
            //input.attr('disabled', 'disabled');
        }
    });
}

function checkPassword(){
    console.log('check password');
  $("#passwordDiv").fadeOut(500, function() { $(this).css("display", "none"); });
  var pswd = $("#pass").val();
  sendDataToServer('password', pswd);
}

